; following steps in tree bark tutorial by conbagui
; found at link: http://gimpchat.com/viewtopic.php?f=23&t=10523
; author: Tin Tran
; date: 2014

(define (script-fu-tree-bark image layer
                       inner-glow-color
					   bevel-and-emboss-highlight-color
                       gray-bark-texture
					   bark-texture
         )
	(let* 
		(
		(dummy-variable-to-make-let-happy 0)
		(image-height (car (gimp-image-height image)))
		)
	(gimp-image-undo-group-start image)                   ;undo-group in one step
	(gimp-item-set-visible layer FALSE)
	;step 8
	(python-layer-fx-inner-shadow 1 image layer '(0 0 0)
                                  70  ;opacity
                                  0   ;0 for Linear contour
                                  0   ;noise
								  3   ;mode 19 for softlight 3 for multiply
								  1   ;source 0 for center 1 for edge check this one
								  14.0 ;choke
								  10  ;size
								  -45    ;offset-angle
								  12   ;offset-distance
								  FALSE ; merge with layer
	)
	;step 9
	(python-layer-fx-inner-glow 1 image layer inner-glow-color
	                              65 ;opacity
	                              0  ;contour 0 for linear
								  0  ;noise
								  16  ;mode 3 for multiply 16 for dodge
								  1  ;source 0 center 1 for edge
								  10.0 ;choke
								  10  ;size
								  FALSE ;merge with layer
	)
	;step 10
	(python-layer-fx-bevel-emboss 1
	                              image
								  layer
								  1 ;style 2 = emboss 1=inner bevel
								  65 ;depth
								  0  ;direction 0 up 1 down
								  12 ;size
								  0  ;soften
								  135 ;angle
								  35.0 ;altitude
									0   ;gloss-contour 0 for linear
								 bevel-and-emboss-highlight-color ;highlight color
								 5 ;highlight mode 5 OVERLAY
								 45.0  ;highlight opacity
	                             '(0 0 0)   ;shadow color
								    19        ;shadow mode 3 multiply 19=softlight
	                              63.0      ;shadow opacity
								     0       ;surface 0=linear
									TRUE     ; use texture
                                   gray-bark-texture ;pattern	use clipboard from the copied step above
								   35     ;scale
								   100     ;depth
								   FALSE   ;invert
								   FALSE   ;merge with layer
     )
	 ;step 11
	 (python-layer-fx-satin 1
	                       image
						   layer
						  '(0 0 0)       ;color
							70.0	 ;opacity
							3	 ;mode 19 softlight mode 3=multiply
							19	 ;off-set angle
							10.0	 ;off-set-distance
							12	 ;size
							5	 ;contour 6halfround 5gaussian
							FALSE	 ;invert
						    FALSE ;merge
	)
	;step 12
	(gimp-context-set-default-colors)
	(python-layer-fx-gradient-overlay 1
	                                  image
									  layer
									  "FG to Transparent" ;gradient
									  0 ;gradient-type 0 linear
									  0 ;repeat 0 none
									  FALSE ;reverse
									  70.0  ;opacity
									   19 ;mode 15 divide 19=softlight
									  0.0 ;center-x
									  (* (/ 400 895) image-height) ;center y is now a percentage of original size from tutorial (650/1200)
                                      90.0  ;angle
                                      200.0 ;gradient width
                                      FALSE ;merge with layer
	)
	;step 13
	(python-layer-fx-pattern-overlay 1
	                                 image
									 layer
									 bark-texture ;pattern
									 100 ;opacity
									 0 ; mode 0 normal
									 35.0 ;scale
									 0 ;interpolation 0 none
									 FALSE ;merge with layer
    )
	(gimp-image-undo-group-end image)                     ;undo group in one step
	(gimp-displays-flush)
	) ;end of let
)     ;end of define
	  
(script-fu-register
  "script-fu-tree-bark"         ;function name
  "<Image>/Script-Fu/Alpha-to-Logo/Tree bark"    ;menu register
  "Creates tree bark effect."       ;description
  "Tin Tran"                          ;author name
  "copyright info and description"         ;copyright info or description
  "2014"                          ;date
  "RGB*, GRAY*"                        ;mode
  SF-IMAGE      "Image" 0                   
  SF-DRAWABLE   "Layer" 0
  SF-COLOR       "Inner glow color"       '(203 190 99)
  SF-COLOR       "Bevel and Emboss Highlight color" '(247 219 152)
  SF-PATTERN     "Gray bark texture" "mossy bark texture gray.jpg"
  SF-PATTERN     "Mossy bark texture" "Mossy bark texture.jpg"
)